/***************************************************************************
                          kpictorial.h  -  description
                             -------------------
    begin                : Thu Apr 18 21:10:17 MEST 2002
    copyright            : (C) 2002 by Roland Lezuo
    email                : roland.lezuo@chello.at
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KPICTORIAL_H
#define KPICTORIAL_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kapp.h>
#include <qwidget.h>
#include <kmainwindow.h>
#include <kfiledialog.h>
#include <kmessagebox.h>
#include <kstdaction.h>
#include <kaction.h>
#include <kwinmodule.h>
#include <kstatusbar.h>
#include "kpictorialview.h"
#include "kpictorialdoc.h"

class Kpictorial : public KMainWindow
{
Q_OBJECT
	public:
	Kpictorial(QWidget* parent=0, const char *name=0);
	~Kpictorial();

	public slots:

	void slotNewDoc(); 			//this is called whenever the user open a document
	void slotNewDocRandom();		//when he wants a new random one
	void slotCheckPicture();			//when he wants to check his work for correctness
	void slotSolvePicture();			//when he is giving up and wants to see what is has been
	void slotQuit();				//when he is bored and doesn't want to play any more
	void slotStatusMessage(const QString &);	//This will be displayed int the status bar
	void slotOptionDifficulty(int);			//whenever he canges level of difficulty (also starts a new game!)
	void slotSaveAs();						//whenever the user wants to save a game
	void slotToggleStatusbar();
	void slotToggleToolbar();
	void slotUndo();			//when user clicks undo
	bool queryExit();			//reimplements default queryExit to saveProperties();

	protected slots:
	void slotUndoEmpty(bool);	//this activates/disables the undo action, trigged by KpictorialView's signal undo_empty(bool)


	protected:
	void resizeEvent(QResizeEvent *);			//when the mainwindow is resized, the view has to be notifyed

	private:
	KpictorialView *view;	
	KPopupMenu *file;
	KAction *actionCheck;
	KAction *actionSolve;
	KAction *actionUndo;
	KConfig *config;
	int difficulty;			//0...easy, 1...medium, 2...hard, 3...harder
	bool toolbar_visible, statusbar_visible;

	public:
	static const int DiffEasy = 0;
	static const int DiffMedium = 1;
	static const int DiffHard = 2;
	static const int DiffHarder = 3;
	static const int DiffRandom = 0xFF;

	signals:
	void resized();
};

#endif
