/***************************************************************************
                          kpictorialdoc.h  -  description
                             -------------------
    begin                : Fri Apr 19 2002
    copyright            : (C) 2002 by Roland Lezuo
    email                : roland.lezuo@chello.at
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KPICTORIALDOC_H
#define KPICTORIALDOC_H

#include <stdlib.h>
#include <qstring.h>
#include <qfile.h>
#include <qstringlist.h>
#include <kapplication.h>
#include <qregexp.h>

/**
  *@author Roland Lezuo
  *
  *	this class is doing every IO which includes
  *	reading XPM and XBM files
  *	reading  Kpictorials own datafiles writing is done elsewhere
  *
  *
  */

class KpictorialDoc {

	public:
	KpictorialDoc(QString);		//only decides which parses to use
	KpictorialDoc(int,int);		//this creates a random picture of given size, srand should be called somewhere else!
	~KpictorialDoc();		
	//this MUST be called after creating this class, returns true, when there is a valid picture, else everything is undefined!
	bool statusOk();  			
	const void * getPicture();		//this returns the picture, 0 is white, 1 is black, treat is as an char*
	/*
          	this only applys when the data read was an KDF file, treated as a char* 0...white,1...black,2...gray
		NULL for XPM and XBM files
	*/
	void * getUserPicture();			//retruns pointer only, must not be freed by caller
	bool controlPicture(const void *);	//checks wheter the input is equal the image, 0 white, 1black, treat as char*
	int getPictureX();				//returns X dimension of picture
	int getPictureY();				//y dimension
	bool saveAs(QString);			//saves the picture + what user already guessed in kdf format, QString = filename

	//returns the number of contigous black blocks in Y direction (to be written in X direction) of given column (0...X)
	//output can be put on a QCanvas directly
	QString* getPictureInfoX(int);	
	QString* getPictureInfoY(int);		//same for rows

	private:
	int isDefinite();			//TODO: decide wheter a picture is definite (seems to be a very complex problem)
	void parseXPM(QString);	//this parses XPM files
	void parseXBM(QString);	//this parses XBM files
	void parseKDF(QString);	//this parses KDF (KpictorialDataFile) files
	//this convert a string to an integer, QString may be hex 0x.. 0X... or decimal, bool is true when convert was ok
	unsigned int convertInt(QString, bool *);

	private:
	int pictx, picty;
	void *picture;
	void *userpicture;
	bool statusok;

};

#endif
