/***************************************************************************
                          kpictorialdocwriter.cpp  -  description
                             -------------------
    begin                : Sun Jun 2 2002
    copyright            : (C) 2002 by Roland Lezuo
    email                : roland.lezuo@chello.at
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kpictorialdocwriter.h"

KpictorialDocWriter::KpictorialDocWriter(){
}
KpictorialDocWriter::~KpictorialDocWriter(){
}

//writes a file in kdf file format which is defined as follows:
/*
	file format: (pretty baindead)
		sizeX.sizeY.pict.upict.
       no whitespaces allowed
	all numbers in decimal format
	upict and pict are of size sizeX * sizeY
	pict is made of 0 and 1
	upict of 0, 1 and 2
	where 0...white pixel, 1...black pixel, 2...gray pixel
	pict...the picture the user should guess
	upict...the picture the user has guessed so far
*/
bool KpictorialDocWriter::write(QString name, int x, int y, const void *pict, const void *upict)	{

	QFile *file = new QFile(name);
	QString str;
	int i;

	//we simple overwrite
	if (!file->open(IO_WriteOnly | IO_Truncate))	{
		qDebug("KpictorialDocWriter::write can't open for writing %s", name.latin1());
		delete file;
		return false;
	}
	str = QString::number(x);
	file->writeBlock(str.latin1(), str.length());
	file->putch('.');
	str = QString::number(y);
	file->writeBlock(str.latin1(), str.length());
	file->putch('.');
	for (i=0; i<x*y; i++)
		file->putch( *((char*)pict +i) + '0' );	
	file->putch('.');
	for (i=0; i<x*y; i++)
		file->putch( *((char*)upict +i) + '0' );	
	file->putch('.');
	file->close();
	delete file;
	return true;
}
